//PAL16.H: Routinen fr das Beispielprogramm PAL16.C
//Coded by Adok.

// Einzelnes Zeichen ausgeben
void chartm(unsigned char zeichen,unsigned char attr,
	    unsigned char xpos,   unsigned char ypos)
{
  unsigned int offs=ypos*160+xpos*2;

  asm {
    mov ax,0xb800
    mov es,ax
    mov bx,offs
    mov al,zeichen
    mov es:[bx],al
    inc bx
    mov al,attr
    mov es:[bx],al
  }
}

// Bildschirmmodus wechseln
void screen(unsigned int number)
{
  asm {
    mov ax,number
    int 0x10
  }
}

// RGB-Werte setzen
void setpal(char col,char r,char g,char b)
{
  outp(0x3c8,col);
  outp(0x3c9,r);
  outp(0x3c9,g);
  outp(0x3c9,b);
}

// Text ausgeben
void texttm(unsigned char *text,unsigned char attr,
	    unsigned char xpos, unsigned char ypos)
{
  unsigned char counter=0;

  while(text[counter]!='\0')
    chartm(text[counter++],attr,xpos++,ypos);
}
