//SCRLHORZ.C: horizontales Smoothscrolling im Textmodus
//Coded by Adok.

#include "scrlhorz.h"

void main()
{
  unsigned char pixel;               //Pixel-Zhler
  int ofs;                           //Offset-Zhler

  //Erste vier Bildschirmseiten lschen
  for(pixel=0;pixel<=3;pixel++) clstm(pixel);

  //Text anzeigen
  texttm("Hallo! Dieses Demonstrationsprogramm zeigt, wie man im Textmode hor"
         "izontal smooth-scrollen kann. I hope you like it... und mge es euc"
         "h Nutzen bringen.",15,0,49);

  //ATC initialisieren (durch Lesezugriff aus IS-Register 1)
  asm {
    mov dx,0x3da
    in al,dx
  }

  //ROW-Offset vervierfachen (160)
  asm {
    mov dx,0x3d4
    mov al,0x13
    out dx,al
    mov dx,0x3d5
    mov al,160
    out dx,al
  }

  //Scrolling (des Texts) nach links
  //(der Bildschirm geht eigentlich nach rechts)
  for(ofs=1;ofs<=239;ofs++)
  {
    for(pixel=0;pixel<=7;pixel++)    //Pixelweise nach links pannen
    {
      waitretrace();
      asm {
        mov dx,0x3c0
        mov al,0x13 or 32
        out dx,al
        mov al,pixel
        out dx,al
      }
    }
    setstartoffstm(ofs);             //Neuen Startoffset setzen
    waitretrace();
    asm {                            //Horizontal Panning abschalten
      mov dx,0x3c0
      mov al,0x13 or 32
      out dx,al
      mov al,8
      out dx,al
    }
  }

  //Bildschirmspeicher reorganisieren - das erledigt Int. 10h Fkt. 0 sehr gut
  asm {
    mov ax,3
    int 0x10
  }
}