//SCRLHORZ.H: Routinen fr das Beispielprogramm SCRLHORZ.C
//Coded by Adok.

//Bildschirmseite lschen
void clstm(unsigned int page)
{
  page*=4000;

  asm {
    cld
    mov cx,4000
    mov ax,0xb800
    mov es,ax
    mov di,word ptr page
    xor ax,ax
    rep stosw
  }
}

//Einzelnes Zeichen ausgeben
void chartm(unsigned char zeichen,unsigned char attr,
	    unsigned char xpos,   unsigned char ypos)
{
  unsigned int offs=ypos*160+xpos*2;

  asm {
    mov ax,0xb800
    mov es,ax
    mov bx,offs
    mov al,zeichen
    mov es:[bx],al
    inc bx
    mov al,attr
    mov es:[bx],al
  }
}

//Startoffset setzen
void setstartoffstm(unsigned int wrd)
{
  asm {
    mov dx,0x3d4
    mov al,0xd
    out dx,al
    mov ax,word ptr wrd
    mov dx,0x3d5
    out dx,al

    mov dx,0x3d4
    mov al,0xc
    out dx,al
    mov ax,word ptr wrd
    mov al,ah
    mov dx,0x3d5
    out dx,al
  }
}

//Text ausgeben
void texttm(unsigned char *text,unsigned char attr,
	    unsigned char xpos, unsigned char ypos)
{
  unsigned char counter=0;

  while(text[counter]!='\0')
    chartm(text[counter++],attr,xpos++,ypos);
}

//Ende des laufenden vertikalen Retrace abwarten und auf einen neuen warten
void waitretrace(void)
{
 while( (inp(0x3da)&8)!=0 );
 while( (inp(0x3da)&8)==0 );
}
