//PAL16.C: Dieses Programm zeigt, wie man in den 16-Farben-Modi auch die
//Farbcodes >= 8 verndern kann. Dies ist nmlich nicht ohne weiteres mglich,
//sondern erst, wenn ein Bit im ATC-Register 10h verndert wurde.
//Coded by Adok.

#include <conio.h>
#include "pal16.h"

void main()
{
  texttm("Hello World!",8,0,0);
  texttm("Ich verndere die RGB-Werte dieser Farbe auf Rot.",8,0,2);

  //Farbe 8 auf Rot ndern
  setpal(8,63,0,0);

  texttm("Nanu, warum hat sich denn nichts getan???",8,0,4);
  texttm("Natrlich, denn ich mu noch einiges erledigen, damit es fruchtet!"
          ,8,0,5);

  //Auf Tastendruck warten
  getch();

  //Vernderung der RGB-Werte der Farbe ermglichen
  asm {
    mov dx,0x3da       //ATC initialisieren
    in al,dx

    mov dx,0x3c0       //EGA-Farben auf Farboffsets ab 0 legen
    mov al,0x14 or 32  //(im ATC-Register 14h)
    out dx,al
    mov al,0
    out dx,al

    mov al,0x10 or 32  //ATC-Register 10h wie folgt einstellen:
    out dx,al          //- Bit 7=1 => Farbl. 4, 5 aus ATC 14h
    mov al,132         //- Bit 3=0 => freie Benutzung aller Farben erlauben
    out dx,al          //- Bit 0=0 => Textmodus (in Grafik-Modi auf 1 setzen!)
  }

  texttm("Naaaa, nun ist es schon viel besser!",8,0,7);

  //Auf Tastendruck warten
  getch();

  screen(3);
}